Subject: Re: [PATCH net-next v3 08/47] net: phylink: Support differing link speeds and interface speeds

From: "Russell King (Oracle)" <[email-masked]>
Date: Mon, 18 Jul 2022 19:01:30 +0100

On Mon, Jul 18, 2022 at 07:28:58PM +0200, Andrew Lunn wrote:
> > > I am rather worried that we have drivers using ->speed today in their
> > > mac_config and we're redefining what that means in this patch.
> > 
> > Well, kind of. Previously, interface speed was defined to be link speed,
> > and both were just "speed". The MAC driver doesn't really care what the
> > link speed is if there is a phy, just how fast the phy interface mode
> > speed is.
> 
> I'm not sure that is true. At least for SGMII, the MAC is passed the
> line side speed, which can be 10, 100, or 1G. The PHY interface mode
> speed is fixed at 1G, since it is SGMII, but the MAC needs to know if
> it needs to repeat symbols because the line side speed is lower than
> the host side speed.

... and passing the SGMII link speed (1G) will break a lot of stuff
where the MAC/PCS may need to know the media speed to do the right
number of symbol replication.

So I don't think we can get away with just saying ->speed is the link
speed which will prevent drivers breaking. I don't think it's that
simple. Like everything with phylink, all the drivers need to be looked
at and tweaked with every damn change, which makes phylink development
painfully slow.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 40Mbps down 10Mbps up. Decent connectivity at last!